<!-- =========================================================================================
    File Name: TodoItem.vue
    Description: Single todo item component
========================================================================================== -->

<template>
  <div @click="$emit('edit', taskLocal)" class="px-4 py-4 list-item-component">
    <div class="vx-row">
      <div
        class="vx-col w-full sm:w-5/6 flex sm:items-center sm:flex-row flex-col"
      >
        <div class="flex items-center">
          <vs-checkbox
            @click.stop
            v-model="isCompleted"
            class="w-8 m-0 vs-checkbox-small"
          />
          <h6 class="todo-title">
            {{ taskLocal.name }}
          </h6>
        </div>
        <div class="todo-tags sm:ml-2 sm:my-0 my-2 flex">
          <vs-chip v-for="(label, index) in taskLocal.labels" :key="index">
            <div
              class="h-2 w-2 rounded-full mr-1"
              :style="'background-color:' + labelColor(label)"
            ></div>
            <span>{{ label.name | capitalize }}</span>
          </vs-chip>
          <vs-chip :color="labelColor(taskLocal.project)">
            <feather-icon icon="BriefcaseIcon" svgClasses="w-3 h-3" />
            <div
              class="h-2 w-2 rounded-full mr-1"
              :style="'background-color:' + labelColor(taskLocal.project)"
            ></div>
            <span>{{ taskLocal.project.name | capitalize }}</span>
          </vs-chip>
        </div>
      </div>

      <div class="vx-col w-full sm:w-1/6 ml-auto flex sm:justify-end">
        <feather-icon
          icon="FlagIcon"
          svgClasses="h-5 w-5 mr-4"
          @click.prevent
          :style="{ color: priorityColor(taskLocal) }"
        ></feather-icon>
        <feather-icon
          icon="InfoIcon"
          class="cursor-pointer"
          :svgClasses="[
            { 'text-success stroke-current': taskLocal.isImportant },
            'w-5',
            'h-5 mr-4'
          ]"
          @click.stop="toggleIsImportant"
        />
        <feather-icon
          icon="StarIcon"
          class="cursor-pointer"
          :svgClasses="[
            { 'text-warning stroke-current': taskLocal.isStarred },
            'w-5',
            'h-5 mr-4'
          ]"
          @click.stop="toggleIsStarred"
        />
        <feather-icon
          v-if="!taskLocal.isTrashed"
          icon="TrashIcon"
          class="cursor-pointer"
          svgClasses="w-5 h-5"
          @click.stop="moveToTrash"
        />
      </div>
    </div>
    <div class="vx-row" v-if="taskLocal.description">
      <div class="vx-col w-full">
        <p class="mt-2 truncate">
          {{ taskLocal.description }}
        </p>
      </div>
    </div>
  </div>
</template>

<script>
import { todoLabelColor, todoPriorityColor } from "../../core/utils/color";

export default {
  props: {
    taskId: {
      type: String,
      required: true
    }
  },
  data() {
    return {
      taskLocal: this.$store.getters["todo/getTask"](this.taskId)
    };
  },
  computed: {
    isCompleted: {
      get() {
        return this.taskLocal.isCompleted;
      },
      set(value) {
        const payload = {
          task: Object.assign({}, this.taskLocal, {
            isCompleted: value,
            completedDate: value == true ? new Date().toISOString() : ""
          }),
          notify: this.$vs.notify
        };

        this.$store
          .dispatch("todo/updateTask", Object.assign({}, payload))
          .then(response => {
            this.taskLocal.isCompleted = response.result.isCompleted;
          })
          .catch(error => {
            console.error(error);
          });
      }
    },
    labelColor() {
      return label => {
        return todoLabelColor(label.color).color;
      };
    },
    priorityColor() {
      return task => {
        const code = todoPriorityColor(task.priority).color;
        return todoLabelColor(code).color;
      };
    }
  },
  methods: {
    toggleIsImportant() {
      const payload = {
        task: Object.assign({}, this.taskLocal, {
          isImportant: !this.taskLocal.isImportant
        }),
        notify: this.$vs.notify
      };

      this.$store
        .dispatch("todo/updateTask", payload)
        .then(response => {
          this.taskLocal.isImportant = response.result.isImportant;
        })
        .catch(error => {
          console.error(error);
        });
    },
    toggleIsStarred() {
      const payload = {
        task: Object.assign({}, this.taskLocal, {
          isStarred: !this.taskLocal.isStarred
        }),
        notify: this.$vs.notify
      };

      this.$store
        .dispatch("todo/updateTask", payload)
        .then(response => {
          this.taskLocal.isStarred = response.result.isStarred;
        })
        .catch(error => {
          console.error(error);
        });
    },
    moveToTrash() {
      const payload = {
        task: Object.assign({}, this.taskLocal, {
          isTrashed: true
        }),
        notify: this.$vs.notify
      };

      this.$store
        .dispatch("todo/updateTask", payload)
        .then(response => {
          this.taskLocal.isTrashed = response.result.isTrashed;
          this.$el.style.display = "none"; // Hides element from DOM
        })
        .catch(error => {
          console.error(error);
        });

      // Un-comment below line if you want to fetch task after task is deleted
      // this.$store.dispatch("todo/fetchTasks", {filter: this.$route.params.filter})
    }
  }
};
</script>
